/*
 * KxElementsCtrl.java
 *
 * Created on 24 septembre 2008, 08:33
 */

package org.cocktail.kiwi.client.nibctrl;

import java.awt.BorderLayout;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.kiwi.client.metier.EOFournis;
import org.cocktail.kiwi.client.metier.EOTypeTransport;
import org.cocktail.kiwi.client.metier.EOVehicule;
import org.cocktail.kiwi.common.utilities.CocktailConstantes;
import org.cocktail.kiwi.common.utilities.CocktailIcones;

import com.webobjects.eointerface.EODisplayGroup;
import com.webobjects.foundation.NSArray;
/**
 *
 * @author  cpinsard
 */
public class VehiculesView extends javax.swing.JFrame {

   	protected EODisplayGroup eod;
	protected ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;

    /** Creates new form KxElementsCtrl */
    public VehiculesView() {
        
    	eod = new EODisplayGroup();
    	
        initComponents();

        initGui();

    }

    public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

	/** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        viewTable = new javax.swing.JPanel();
        buttonClose = new javax.swing.JButton();
        nomFinder = new javax.swing.JTextField();
        prenomFinder = new javax.swing.JTextField();
        buttonAdd = new javax.swing.JButton();
        buttonUpdate = new javax.swing.JButton();
        buttonDelete = new javax.swing.JButton();
        lblNbVehicules = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        typesTransport = new javax.swing.JComboBox();
        checkValide = new javax.swing.JRadioButton();
        checkHistorise = new javax.swing.JRadioButton();
        buttonDetail = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Gestion des véhicules");

        viewTable.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        viewTable.setLayout(new java.awt.BorderLayout());

        buttonClose.setText("Fermer");
        buttonClose.setToolTipText("Fermer la fenêtre");
        buttonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCloseActionPerformed(evt);
            }
        });

        nomFinder.setFont(new java.awt.Font("Tahoma", 0, 10));

        prenomFinder.setFont(new java.awt.Font("Tahoma", 0, 10));

        buttonAdd.setToolTipText("Ajouter un nouveau véhicule");

        buttonUpdate.setToolTipText("Modifier le véhicule sélectionné");

        buttonDelete.setToolTipText("Suppression du véhicule sélectionné");

        lblNbVehicules.setForeground(new java.awt.Color(102, 102, 255));

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel7.setText("Type :");

        typesTransport.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        typesTransport.setToolTipText("Puissance du véhicule");
        typesTransport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                typesTransportActionPerformed(evt);
            }
        });

        buttonGroup1.add(checkValide);
        checkValide.setText("Valides");
        checkValide.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkValideActionPerformed(evt);
            }
        });

        buttonGroup1.add(checkHistorise);
        checkHistorise.setText("Historisés");
        checkHistorise.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkHistoriseActionPerformed(evt);
            }
        });

        buttonDetail.setToolTipText("Suppression du véhicule sélectionné");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(layout.createSequentialGroup()
                        .add(lblNbVehicules, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 111, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(456, 456, 456)
                        .add(buttonClose, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 94, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                                .add(nomFinder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 124, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(prenomFinder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 103, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                .add(jLabel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 54, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(typesTransport, 0, 234, Short.MAX_VALUE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(checkValide, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(checkHistorise))
                            .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 680, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(buttonDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(buttonDelete, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(buttonUpdate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(buttonAdd, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(nomFinder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(prenomFinder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel7)
                    .add(typesTransport, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(checkValide)
                    .add(checkHistorise))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(buttonAdd, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonUpdate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonDelete, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(18, 18, 18)
                        .add(buttonDetail, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 546, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(lblNbVehicules, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(buttonClose))
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-752)/2, (screenSize.height-666)/2, 752, 666);
    }// </editor-fold>//GEN-END:initComponents

private void buttonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCloseActionPerformed
// TODO add your handling code here:
    dispose();
}//GEN-LAST:event_buttonCloseActionPerformed

private void typesTransportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_typesTransportActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_typesTransportActionPerformed

private void checkValideActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkValideActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_checkValideActionPerformed

private void checkHistoriseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkHistoriseActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_checkHistoriseActionPerformed

//    /**
//    * @param args the command line arguments
//    */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new KxElementsView().setVisible(true);
//            }
//        });
//    }

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JButton buttonAdd;
    private javax.swing.JButton buttonClose;
    protected javax.swing.JButton buttonDelete;
    protected javax.swing.JButton buttonDetail;
    private javax.swing.ButtonGroup buttonGroup1;
    protected javax.swing.JButton buttonUpdate;
    private javax.swing.JRadioButton checkHistorise;
    private javax.swing.JRadioButton checkValide;
    private javax.swing.JLabel jLabel7;
    protected javax.swing.JLabel lblNbVehicules;
    protected javax.swing.JTextField nomFinder;
    protected javax.swing.JTextField prenomFinder;
    protected javax.swing.JComboBox typesTransport;
    private javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables

        
    protected void setTypes (NSArray types) {
        
        typesTransport.removeAllItems();
        
        for (int i=0;i<types.count();i++) {
            typesTransport.addItem(types.objectAtIndex(i));
        }
        
    }
        
        
    public ZEOTableModel getMyTableModel() {
		return myTableModel;
	}

	public void setMyTableModel(ZEOTableModel myTableModel) {
		this.myTableModel = myTableModel;
	}

	public javax.swing.JButton getButtonAdd() {
		return buttonAdd;
	}

	public void setButtonAdd(javax.swing.JButton buttonAdd) {
		this.buttonAdd = buttonAdd;
	}

	public javax.swing.JButton getButtonClose() {
		return buttonClose;
	}

	public void setButtonClose(javax.swing.JButton buttonClose) {
		this.buttonClose = buttonClose;
	}

	public javax.swing.JButton getButtonDelete() {
		return buttonDelete;
	}

	public void setButtonDelete(javax.swing.JButton buttonDelete) {
		this.buttonDelete = buttonDelete;
	}

	public javax.swing.JButton getButtonUpdate() {
		return buttonUpdate;
	}

	public void setButtonUpdate(javax.swing.JButton buttonUpdate) {
		this.buttonUpdate = buttonUpdate;
	}

	public javax.swing.JLabel getLblNbVehicules() {
		return lblNbVehicules;
	}

	public void setLblNbVehicules(javax.swing.JLabel lblNbVehicules) {
		this.lblNbVehicules = lblNbVehicules;
	}

	public javax.swing.JTextField getNomFinder() {
		return nomFinder;
	}

	public void setNomFinder(javax.swing.JTextField nomFinder) {
		this.nomFinder = nomFinder;
	}

	public javax.swing.JTextField getPrenomFinder() {
		return prenomFinder;
	}

	public void setPrenomFinder(javax.swing.JTextField prenomFinder) {
		this.prenomFinder = prenomFinder;
	}

	public javax.swing.JComboBox getTypesTransport() {
		return typesTransport;
	}

	public void setTypesTransport(javax.swing.JComboBox typesTransport) {
		this.typesTransport = typesTransport;
	}

	public javax.swing.JRadioButton getCheckHistorise() {
		return checkHistorise;
	}

	public void setCheckHistorise(javax.swing.JRadioButton checkHistorise) {
		this.checkHistorise = checkHistorise;
	}

	public javax.swing.JRadioButton getCheckValide() {
		return checkValide;
	}

	public javax.swing.JButton getButtonDetail() {
		return buttonDetail;
	}

	public void setButtonDetail(javax.swing.JButton buttonDetail) {
		this.buttonDetail = buttonDetail;
	}

	public void setCheckValide(javax.swing.JRadioButton checkValide) {
		this.checkValide = checkValide;
	}

	private void initGui() {
    	                
        buttonClose.setIcon(CocktailIcones.ICON_CLOSE);
                
        buttonAdd.setIcon(CocktailIcones.ICON_ADD);
        buttonUpdate.setIcon(CocktailIcones.ICON_UPDATE);
        buttonDelete.setIcon(CocktailIcones.ICON_DELETE);

        buttonDetail.setIcon(CocktailIcones.ICON_LOUPE_16);

        Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();
		
		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, EOVehicule.FOURNIS_KEY+"."+EOFournis.NOM_KEY, "NOM", 150);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOVehicule.FOURNIS_KEY+"."+EOFournis.PRENOM_KEY, "PRENOM", 125);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOVehicule.VEH_IMMATRICULATION_KEY, "Immat.", 100);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOVehicule.VEH_MARQUE_KEY, "Marque", 125);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOVehicule.VEH_PUISSANCE_KEY, "PF", 75);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOVehicule.VEH_COMPAGNIE_KEY, "Cie", 75);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOVehicule.TYPE_TRANSPORT_KEY+"."+EOTypeTransport.TTR_TYPE_KEY, "TYPE", 50);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
                
		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		//myEOTable.addListener(myListenerContrat);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setBackground(CocktailConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTable.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

    }

}
